<template>
  <div class=" mt-5">
    <div class="row justify-content-center center">
      <div class="col-md-8 col-lg-5">
        <div class="card">
          <div class="card-header">Register</div>
          <div class="card-body">
            <form>
              <div class="form-group row">
                <label for="username" class="col-md-4 col-form-label text-md-right">Userame</label>
                <div class="col-md-6">
                  <input
                    id="username"
                    type="text"
                    class="input-border-less form-control"
                    name="username"
                    required
                    autofocus
                    v-model="name"
                  >
                </div>
              </div>

              <div class="form-group row">
                <label for="email" class="col-md-4 col-form-label text-md-right">E-Mail Address</label>

                <div class="col-md-6">
                  <input
                    id="email"
                    type="email"
                    class="input-border-less form-control"
                    required
                    v-model="email"
                  >
                </div>
              </div>

              <div class="form-group row">
                <label for="password" class="col-md-4 col-form-label text-md-right">Password</label>

                <div class="col-md-6">
                  <input
                    id="password"
                    type="password"
                    class="input-border-less form-control"
                    name="password"
                    required
                    v-model="password"
                  >
                </div>
              </div>

              <div class="form-group row">
                <label
                  for="password-confirm"
                  class="col-md-4 col-form-label text-md-right"
                >Confirm Password</label>

                <div class="col-md-6">
                  <input
                    id="password-confirm"
                    type="password"
                    class="input-border-less form-control"
                    name="password_confirmation"
                    required
                    v-model="password_confirmation"
                  >
                </div>
              </div>

              <div class="form-group row mb-0">
                <div class="col-md-6 offset-md-4">
                  <button type="submit" class="btn btn-primary" @click="handleSubmit">Register</button>
                </div>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import EventBus from "@/main";
export default {
  props: ["nextUrl"],
  data() {
    return {
      name: "",
      email: "",
      password: "",
      password_confirmation: ""
    };
  },
  methods: {
    handleSubmit(e) {
      e.preventDefault();
      if (
        this.password === this.password_confirmation &&
        this.password.length > 0
      ) {
        this.$socket.emit("register", {
          body: {
            name: this.name.trim().toLowerCase(),
            email: this.email.trim().toLowerCase(),
            password: this.password.trim()
          }
        });
        this.$socket.on("registerOk", response => {
          let is_admin = response.body.user.is_admin;
          localStorage.setItem("user", JSON.stringify(response.body.user));
          localStorage.setItem("jwt", response.body.token);
          EventBus.$emit("updateUser",response.body.user);
          if (localStorage.getItem("jwt") != null) {
            this.$emit("loggedIn");
            if (this.$route.params.nextUrl != null) {
              this.$router.push(this.$route.params.nextUrl);
            } else {
              if (is_admin == 1) {
                this.$router.push("admin");
              } else {
                this.$router.push("dashboard/" + response.body.user.name);
              }
            }
          }
        });
        this.$socket.on("registerKo", response => {
          this.$toastr.error(response, "Registration Failed", {
            preventDuplicates: true,
            progressBar: true
          });
        });
      } else {
        this.password = "";
        this.passwordConfirm = "";

        this.$toastr.error("Passwords do not match", "Registration Failed", {
          preventDuplicates: true,
          progressBar: true
        });
      }
    }
  }
};
</script>
<style>
</style>
